/*
 * gattotopo.cpp
 *
 *  Created on: 11-mag-2010
 *      Author: gio
 */
#include <JTC/JTC.h>
#include <iostream>
#include <time.h>

/*
 *  Soluzione che non consente a Display di stampare l'ultimo stato sempre e comunque.
 */
using namespace std;

#define LUNG 80


class Striscia : public JTCMonitor

{
private:
	char    striscia[LUNG+1];
	int      topo;
	int      gatto;
	bool     fine;
	int      dirGatto;

public:
    Striscia()
    {
    	fine = 0;
    	dirGatto = 1;
    	srand(time(0));
    	topo =  rand() % LUNG;
    	gatto = rand() % LUNG;
    	for(int i=0; i < LUNG; i++)
    		striscia[i] = ' ';
    	striscia[LUNG] = '\0';
    	striscia[topo] = '.';
    	striscia[gatto] = '*';
    }

    char* getStriscia()
    {
    	JTCSynchronized sync(*this);
		char* str = new char[LUNG+1];
    	if (!fine)
    	{
    		strcpy(str,(const char*)&striscia);
    		return str;
    	}
    	else return NULL;
    }
    bool muoviTopo()
    {
        JTCSynchronized sync(*this);
        if (fine) return true;
        striscia[topo] = ' ';
        topo = (topo +(rand() % 3 - 1)) % LUNG;
        if (gatto != topo)
        	{
        	striscia[topo] = '.';
        	}
        else {
        	fine = true;
        	return true;
        }
        return false;
    }
    bool muoviGatto()
    {
    	JTCSynchronized sync(*this);
    	striscia[gatto] = ' ';
    	gatto += dirGatto;
    	if (gatto == LUNG || gatto < 0)
    	{
    		dirGatto = -dirGatto;
    	    gatto += dirGatto;
    	}
    	if (gatto == topo)
    	{
    	    fine = true;
    	    striscia[gatto] = '@';
    		return true;
    	}
    	striscia[gatto] = '*';
    	return false;
    }
};
Striscia* s;


class Display : public JTCThread

{
    virtual void run()
    {
    	char* str;
    	cout << "First run Display" << endl;
    	while (str = s->getStriscia())
        {
    		cout << str << "\r";
    		delete str;
    	}

    	cout << "Il topo ha fatto la fine del topo" << endl;
    }
};

class Gatto : public JTCThread

{
	virtual void run()
	{
		cout << "First run Gatto" << endl;
		while( !s->muoviGatto())
			sleep(100);
	}
};

class Topo : public JTCThread
{
	virtual void run()
	{
		cout << "First run Topo" << endl;
		while( !s->muoviTopo() )
			sleep(50);
	}
};


int main()
{
   JTCInitialize init;
   s = new Striscia();
   cout << "Start" << endl;
   Gatto *jerry = new Gatto();
   Topo *tom = new Topo();
   Display *display = new Display();
   cout << "Created" << endl;
   display->start();
   jerry->start();
   tom->start();
   cout << "Started" << endl;
   //sleep(10000);
   return 0;
}
